
#
# RPM spec file for OpenLibraries
#

%define _prefix /usr

Summary: OpenLibraries - a library suite for non-linear editing, visual effects and rich media applications.
Name: openlibraries
Version: 0.4.1
Release: 4
License: LGPL
Group: Development/Frameworks
Source: openlibraries-%{version}.tar.gz
Vendor: OpenLibraries
Packager: Goncalo de Carvalho <goncalo@vmfx.com>
URL: http://www.openlibraries.org
BuildRoot: %{_tmppath}/%name-%{version}-root
Requires: olib-glew >= 1.3.4-4 olib-mlt >= 0.2.2-1 olib-mlt++ >= 0.2.2-1
BuildRequires: olib-glew-devel >= 1.3.4-4 olib-mlt-devel >= 0.2.2-1 olib-mlt++-devel >= 0.2.2-1
Prefix: %{_prefix}

%description
OpenLibraries - a library suite for non-linear editing, visual effects and rich media applications.

%package devel
Summary: OpenLibraries development headers.
Group: Development/Frameworks
Requires: openlibraries = %{version}
Requires: olib-glew >= 1.3.4-4 olib-mlt >= 0.2.2-1 olib-mlt++ >= 0.2.2-1
BuildRequires: olib-glew-devel >= 1.3.4-4 olib-mlt-devel >= 0.2.2-1 olib-mlt++-devel >= 0.2.2-1

%description devel
OpenLibraries development headers/libs.

%package media
Summary: OpenLibraries sample media files.
Group: Development/Frameworks
Requires: openlibraries = %{version}

%description media
OpenLibraries sample media files.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n openlibraries-%{version}

%build
%configure "LDFLAGS=-Wl,--rpath=/usr/olib/0.4.1/lib" --prefix=%{_prefix} --enable-gpl --with-qtinclude=/usr/lib/qt-3.3/include --with-qtlib=/usr/lib/qt-3.3/lib --with-glewprefix=/usr/olib/0.4.1/
make
#find . -name "*.so" -exec strip {} \;

%install
OPENLIBRARIES_INCLUDEPATH="$RPM_BUILD_ROOT$OPENLIBRARIES_INCLUDEPATH" OPENLIBRARIES_LIBPATH="$RPM_BUILD_ROOT$OPENLIBRARIES_LIBPATH" DESTDIR=$RPM_BUILD_ROOT make install

%clean
rm -rf $RPM_BUILD_ROOT

%post 
/sbin/ldconfig

%postun 
/sbin/ldconfig

%files devel
%defattr(-,root,root)
%{_prefix}/include/openlibraries-%{version}/
%{_prefix}/lib/openlibraries-%{version}/include/
%{_prefix}/lib/pkgconfig/openlibraries.pc

%files media
%defattr(-,root,root)
%{_prefix}/share/openlibraries-%{version}/

%files
%defattr(-,root,root)
%{_prefix}/lib/openlibraries-%{version}/openpluginlib
%{_prefix}/lib/openlibraries-%{version}/openimagelib
%{_prefix}/lib/openlibraries-%{version}/openmedialib
%{_prefix}/lib/openlibraries-%{version}/openobjectlib
%{_prefix}/lib/openlibraries-%{version}/openassetlib
%{_prefix}/lib/openlibraries-%{version}/openeffectslib
%{_prefix}/lib/python2.4/site-packages/openpluginlib.so
%{_prefix}/lib/python2.4/site-packages/openimagelib.so
%{_prefix}/lib/python2.4/site-packages/openassetlib.so

%changelog
* Tue Sep 19 2006 Goncalo de Carvalho <goncalo@vmfx.com>
- increased the release number for Jahshaka 2.0
* Mon Aug 16 2006 Goncalo de Carvalho <goncalo@vmfx.com>
- increased the release number for Jahshaka 2.0 RC4
- increased version number
* Mon Jul 24 2006 Goncalo de Carvalho <goncalo@vmfx.com>
- increased the release number for Jahshaka 2.0 RC4
* Mon Nov 21 2005 Goncalo de Carvalho <goncalo@vmfx.com>
- fixes to for installation on FC4
* Sun Nov 20 2005 Goncalo de Carvalho <goncalo@vmfx.com>
- fixes to allow for custom built Boost and GLEW rpms
* Wed Nov 12 2005 Goncalo de Carvalho <goncalo@vmfx.com>
- initial packaging
