
#
#
#

import sys
import os
import optparse
import string

def accept_args( args ):
	parser = optparse.OptionParser( )
	parser.add_option( "-t", "--toolset-version", dest="toolset", metavar="toolset-version", help="compiler toolset (e.g. vc71)" )
	parser.add_option( "-b", "--build-type", dest="build", metavar="build-type", help="build type (e.g. rebuild)" )
	parser.add_option( "-c", "--configuration", dest="configuration", metavar="configuration", help="configuration (e.g. debug)" )
	parser.usage = "winbuild [options]"
	
	( options, args ) = parser.parse_args( args )
	
	libraries = [ 'openpluginlib', 'openimagelib', 'openmedialib', 'openobjectlib', 'openassetlib' ]
	if( len( args ) > 0 ): libraries = args
	
	( toolset, build, configuration ) = ( options.toolset, options.build, options.configuration )
	
	def validate( value, name, default ):
		if( value is None ):
			print "WARNING: %s was not specified. Defaults to %s." % ( name, default )
			return default
			
		return value
			
	toolset = validate( toolset, 'toolset', 'vc8' )
	build = validate( build, 'build type', 'rebuild' )
	configuration = validate( configuration, 'configuration', 'all' )
	
	return( toolset, build, configuration, libraries )

class openlibraries_build:
	def __init__( self, toolset, build, configuration, libraries ):
		self.toolset		= toolset
		self.build			= build
		self.configuration	= configuration
		self.libraries		= libraries
		
	def run( self ):
		self.system( [ self.build_cmd( ) ] )
			
	def toolset_init( self ):
		if( self.toolset == 'vc71' ):
			toolinit='call "%VS71COMNTOOLS%vsvars32.bat"'
		elif( self.toolset == 'vc8' ):
			toolinit='call "%VS80COMNTOOLS%vsvars32.bat"'

		return toolinit
	
	def build_cmd( self ):
		commands = self.toolset_init( ) + '\n';
		for i in self.libraries:
			if( self.configuration == 'debug' ):
				commands += 'devenv %s\%s_%s.sln /%s "Multi-threaded Debug DLL"\n' % ( self.toolset, i, self.toolset, self.build )
			elif( self.configuration == 'release' ):
				commands += 'devenv %s\%s_%s.sln /%s "Multi-threaded Release DLL"\n' % ( self.toolset, i, self.toolset, self.build )
			else:
				commands += 'devenv %s\%s_%s.sln /%s "Multi-threaded Debug DLL"\n' % ( self.toolset, i, self.toolset, self.build )
				commands += 'devenv %s\%s_%s.sln /%s "Multi-threaded Release DLL"\n' % ( self.toolset, i, self.toolset, self.build )
		
		return commands
	
	def system( self, commands ):
		if os.path.exists( "tmp.cmd" ):
			os.chmod( "tmp.cmd", 0777 )
			os.unlink( "tmp.cmd" )

		f = open( "tmp.cmd", "w" )
		f.write( string.join( commands, "\n" ) )
		f.close( )
		rc = os.system( "tmp.cmd" )
		os.chmod( "tmp.cmd", 0777 )
		os.unlink( "tmp.cmd" )

		return rc	

def main( ):
	( toolset, build, configuration, libraries ) = accept_args( sys.argv[ 1: ] )
	
	openlibraries_build( toolset, build, configuration, libraries ).run( )
	
if( __name__ == "__main__" ):
	main( )
